/**
 * FLL - Level 1
 *
 * Project: FSS
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Unlike many of the other base project headers, this does not auto-include all of the headers.
 * Each FSS type has its own base header to include that includes all necessary additional headers as follows:
 *   - basic.h:         The fss-0000 (Basic).
 *   - basic_list.h:    The fss-0002 (Basic List).
 *   - extended.h       The fss-0001 (Extended).
 *   - extended_list.h: The fss-0003 (Extended List).
 *   - payload.h:       The fss-000e (Payload).
 */
#ifndef _FL_fss_h
#define _FL_fss_h

// Libc includes.
#include <ctype.h>
#include <string.h>

// FLL-0 includes.
#include <fll/level_0/type.h>
#include <fll/level_0/status.h>
#include <fll/level_0/memory.h>
#include <fll/level_0/string.h>
#include <fll/level_0/utf.h>
#include <fll/level_0/file.h>
#include <fll/level_0/fss.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _FL_fss_h
