#include "firewall.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_firewall_main_
  void firewall_main(firewall_main_t * const main) {

    if (!main || F_status_is_error(main->setting.state.status)) return;

    main->setting.state.status = F_okay;

    if (main->setting.flag & firewall_main_flag_version_copyright_help_d) {
      if (main->setting.flag & firewall_main_flag_help_d) {
        firewall_print_message_help(&main->program.message);
      }
      else if (main->setting.flag & firewall_main_flag_version_d) {
        fll_program_print_version(&main->program.message, firewall_program_version_s);
      }
      else if (main->setting.flag & firewall_main_flag_copyright_d) {
        fll_program_print_copyright(&main->program.message, fll_program_copyright_year_author_s);
      }

      return;
    }

    if (main->setting.flag & firewall_main_flag_operation_d) {
      firewall_operate(main);
    }
    else {
      main->setting.state.status = F_status_set_error(F_parameter);

      firewall_print_error_operation_specified_not(&main->program.error);
    }

    if (F_status_is_error(main->setting.state.status) || main->setting.state.status == F_interrupt) return;

    main->setting.state.status = F_okay;
  }
#endif // _di_firewall_main_

#ifdef __cplusplus
} // extern "C"
#endif
